import Text.ParserCombinators.Poly.Lazy
import Char

type TextParser a = Parser Char a

digit :: TextParser Char
digit = satisfy Char.isDigit

integer :: TextParser Integer
integer = do ds <- many1 digit
             return (foldl1 (\n d-> n*10+d)
                            (map (fromIntegral.digitToInt) ds))
          `adjustErr` (++("\nexpected one or more digits"))

date = do a <- integer
          satisfy (=='.')
          b <- integer
          satisfy (=='.')
          c <- integer
          return (a,b,c)

lazydate = return (,,) `apply` integer `discard` dot
                       `apply` integer `discard` dot
                       `apply` integer
   where dot = satisfy (=='.')

